/*
    Cred.cpp
*/
#include <stdio.h>
#include <windows.h>
#include <wincred.h>

void main(void) {
    CREDUI_INFO cui;
    cui.cbSize = sizeof CREDUI_INFO;
    cui.hwndParent = NULL;
    cui.pszMessageText = 
            TEXT("Zadejte prosm heslo k tu Northwind Traders.");
    cui.pszCaptionText = TEXT("et Northwind Traders");
    cui.hbmBanner = NULL;

    PCTSTR pszTargetName = TEXT("NorthwindAccountsServer"); 
    DWORD  dwErrReason = 0;
    char   pszName[CREDUI_MAX_USERNAME_LENGTH+1];
    char   pszPwd[CREDUI_MAX_PASSWORD_LENGTH+1];
    DWORD  dwName = CREDUI_MAX_USERNAME_LENGTH; 
    DWORD  dwPwd = CREDUI_MAX_PASSWORD_LENGTH; 
    BOOL   fSave = FALSE;
    DWORD  dwFlags = 
            CREDUI_FLAGS_GENERIC_CREDENTIALS | 
            CREDUI_FLAGS_ALWAYS_SHOW_UI;

    // Vynulujeme uivatelsk jmno a heslo, protoe jsou to 
    // vstupn-vstupn parametry.
    ZeroMemory(pszName, dwName);
    ZeroMemory(pszPwd, dwPwd);
   
    DWORD err = CredUIPromptForCredentials(
               &cui,
               pszTargetName,
               NULL,
               dwErrReason,
               pszName,dwName,
               pszPwd,dwPwd,
               &fSave,
               dwFlags);

    if (err) 
        printf("CredUIPromptForCredentials() selhalo -> %d",
               GetLastError());
    else {
        // Nyn meme se jmnem pszName a heslem pszPwd pistupovat
        // pes bezpen kanl k etnmu balku Northwind Traders.
    }
}
