#include <winsock2.h>
#include <stdio.h>
#include <assert.h>

// Dky tomuto pragma nemusme mnit vchoz projekt
// uiten zejmna pi prci s knihovnami a tdami
#pragma comment(lib, "ws2_32.lib")
/*
Tato funkce inicializuje Winsock.
*/
bool InitWinsock(void)
{
    WORD VersionRequested;
    WSADATA WsaData;
    int ret;

    // dme verzi 2.2
    // mla by pracovat na Windows NT 4.0, Windows 2000 a vych
    VersionRequested = MAKEWORD( 2, 2 );
 
    ret = WSAStartup(VersionRequested, &WsaData);

    if(ret == ERROR_SUCCESS)
    {
        // nesta kontrolovat spch 
        // mme skuten tu verzi, kterou jsme dali?
        if(LOBYTE(WsaData.wVersion) == 2 &&
            HIBYTE(WsaData.wVersion) == 2)
        {
            return true;
        }
        else
        {
            // poznmka  vy bajt je vedlej slo verze
            // ni bajt je hlavn slo verze 
            printf("Winsock 2.2 nen k dispozici\n");
            printf("Winsock %d.%d je nejvy dostupn\n", 
                    LOBYTE(WsaData.wHighVersion),
                    HIBYTE(WsaData.wHighVersion));

            return false;
        }
    }
    else
    {
        printf("Nelze inicializovat Winsock  chyba = %d\n", ret);
        return false;
    }
}

/*
Inicializuje strukturu sockaddr_in, kterou pouvaj bind, connect a dal
Vyuit - 
Pokud nemuste zadvat port  napklad pi svzn klienta UDP 
nebo svzn soketu, kter nen UDP ani TCP, pouijte port = 0

Pokud nen nutn zadat konkrtn IP adresu  napklad pi svzn 
serveru se vemi dostupnmi IP adresami  zadejte IpStr = "0.0.0.0" 
Takto bude funkce inet_ntoa vracet INADDR_ANY

*/

bool InitSockAddr(sockaddr_in* pSa, const char* IpStr, unsigned short port)
{
    unsigned long addr;

    // VDY kontrolujte vstup! 
    // berte to tak, e celmu svtu mimo vai funkci jde jen o vae znien!
    // vborn konstrukce  jste chrnni v ostrm i ladicm kdu 

    // Poznmka - inet_addr nevrac chybu, pokud do n dme ukazatel NULL
    // vrac 0, kter je jinak oznaena jako INADDR_ANY
    // tento mlo znm fakt zpsobil kdysi hodn problm
    // a vedl k objeven novho toku s odepenm slueb
    if(pSa == NULL || IpStr == NULL)
    {
        assert(false);
        return false;
    }

    addr = inet_addr(IpStr);

    if(addr == ~0)
    {
        printf("Vadn etzec IP %s\n", IpStr);
        return false;
    }

    pSa->sin_family = AF_INET;
    pSa->sin_addr.S_un.S_addr = addr;
    pSa->sin_port = htons(port);
    return true;
}
