//include guard
#ifndef SOCKETHELPER_H
#define SOCKETHELPER_H

//pokud nen winsock2.h zalenn, vyhodme chybu 
#ifndef _WINSOCK2API_
#error Nutno zalenit include Winsock2.h 
#endif

/*
Pro ho nedme sem, urit se ptte?
Nikdy nedvejte winsock2.h, winsock.h ANI windows.h do hlaviky,
pokud si nejste 100procentn jisti, e se nkde jinde nezalen jin

Dvod je, e pokud nejprve zalenme include winsock.h, nate se i windows.h
a naopak. Soubor Winsock.h je chrnn proti naten ve winsock2.h, take - 

#include <winsock2.h>
#include <windows.h> NEBO #include <winsock.h>

je redundantn, ale funguje.

Pokud ale radji pete:
#include <windows.h>
#include <winsock2.h>

dostanete stovky chyb kompiltoru a je to k niemu.
Pokud je hlavika naten v jednom z tchto soubor vnoena do jinch hlaviek,
mete ve velkm projektu oekvat obrovsk problmy.
*/

/*
Tato funkce inicializuje Winsock na v2.2
*/
bool InitWinsock(void);

/*
Inicializuje strukturu sockaddr_in, kterou pouvaj bind, connect a dal
Vyuit - 
Pokud nemuste zadvat port  napklad pi svzn klienta UDP 
nebo svzn soketu, kter nen UDP ani TCP, pouijte port = 0

Pokud nen nutn zadat konkrtn IP adresu  napklad pi svzn 
serveru se vemi dostupnmi IP adresami  zadejte IpStr = "0.0.0.0" 
Takto bude funkce inet_ntoa vracet INADDR_ANY

*/

bool InitSockAddr(sockaddr_in* pSa, const char* IpStr, unsigned short port);


#endif
