#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

typedef void (*ErrFunc)(unsigned long);

void GhastlyError(unsigned long err)
{
    printf("Neopraviteln chyba! - err = %d\n", err);

    // Toto je, obecn vzato, patn postup.
    // Ukonen programu, "zakopan" kdesi v knihovnch X Window, 
    // m jednou stly cel tden horenho ladn.
    // Veker pkazy pro ukonen aplikace je teba pst do
    // funkce main, nejlpe pak na jedin msto.
    exit(-1);
}

void RecoverableError(unsigned long err)
{
    printf("Nco nen v podku, ale me to opravit - err = %d\n", err);
}

void PrintMessage(char* file, unsigned long err)
{
    ErrFunc fErrFunc;
    char buf[512];

    if(err == 5)
    {
        // odepen pstupu
        fErrFunc = GhastlyError;
    }
    else
    {
        fErrFunc = RecoverableError;
    }

    _snprintf(buf, sizeof(buf)-1, "Nemohu najt %s", file);

    // tady jen vypeme obsah bufferu 
    printf("%s", buf);
    // pro ppad, e nm kompiltor zmn kd pod rukama 
    printf("\nAdresa fErrFunc je %p\n", &fErrFunc);

    // A tenhle pkaz napch "slben" kody!
    // Vy tohle urit nedlejte!
    fprintf(stdout, buf);

    printf("\nVoln ErrFunc %p\n", fErrFunc);
    fErrFunc(err);

}

void foo(void)
{
    printf("Au! Dostal m hacker!\n");
}

int main(int argc, char* argv[])
{
    FILE* pFile;

    // mal podfuk, kterm si pklad usnadnme 
    printf("Adresa foo je %p\n", foo);

    // tento pkaz oteve jen existujc soubor 
    pFile = fopen(argv[1], "r");

    if(pFile == NULL)
    {
        PrintMessage(argv[1], errno);
    }
    else
    {
        printf("Oteveno %s\n", argv[1]);
        fclose(pFile);
    }
    
    return 0;
}
