/*
  SAFER.cpp
*/
#include <windows.h>
#include <WinSafer.h>
#include <winnt.h>
#include <stdio.h>
#include <strsafe.h>

void main() {
    SAFER_LEVEL_HANDLE hAuthzLevel;

    // Platn programov rovn SAFER:
    //  SAFER_LEVELID_FULLYTRUSTED
    //  SAFER_LEVELID_NORMALUSER
    //  SAFER_LEVELID_CONSTRAINED
    //  SAFER_LEVELID_UNTRUSTED
    //  SAFER_LEVELID_DISALLOWED

    // Vytvoen rovn normlnho uivatele.
    if (SaferCreateLevel(SAFER_SCOPEID_USER,
                         SAFER_LEVELID_NORMALUSER,
                         0, &hAuthzLevel, NULL)) {

        //  Generovn omezenho tokenu, se kterm budeme pracovat.
        HANDLE hToken = NULL;
        if (SaferComputeTokenFromLevel(
            hAuthzLevel,    // Popisova rovn Safer 
            NULL,           //  NULL je token aktulnho vlkna.
            &hToken,        // Clov token
            0,              // Bez pznak
            NULL)) {        // Vyhrazeno 

            // Program Cmd.exe spustme z pln cesty, aby se tak
            // nemohl spustit trojsk k se stejnm nzvem.
            char szPath[MAX_PATH+1], szSysDir[MAX_PATH+1];
            if (GetSystemDirectory(szSysDir, sizeof szSysDir)) {
                _StringCbPrintf(szPath,
                          sizeof szPath,
                          "%s\\cmd.exe",
                          szSysDir);
            
                STARTUPINFO si;
                ZeroMemory(&si, sizeof(STARTUPINFO));
                si.cb = sizeof(STARTUPINFO);
                si.lpDesktop = NULL;
            
                PROCESS_INFORMATION pi;
                if (!CreateProcessAsUser( 
                    hToken,
                    szPath, NULL,
                    NULL, NULL,
                    FALSE, CREATE_NEW_CONSOLE,
                    NULL, NULL,  
                    &si, &pi))
                    printf("CreateProcessAsUser selhalo (%lu)\n",
                           GetLastError() );
            }

        }
        SaferCloseLevel(hAuthzLevel);
    }
}
