/*
  WOWAccess.cpp
*/
#include <stdio.h>
#include <windows.h>

int EnablePriv (char *szPriv) {
    HANDLE hToken = 0;

    if (!OpenProcessToken(GetCurrentProcess(),
                          TOKEN_ADJUST_PRIVILEGES,
                          &hToken)) {
        printf("OpenProcessToken() selhalo - > %d", GetLastError());
        return -1;
    }

    TOKEN_PRIVILEGES newPrivs;
    if (!LookupPrivilegeValue (NULL, szPriv,
                               &newPrivs.Privileges[0].Luid)) {
        printf("LookupPrivilegeValue() selhalo - > %d", GetLastError());
        CloseHandle (hToken);
        return -1;
    }

    newPrivs.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
    newPrivs.PrivilegeCount = 1;
    
    if (!AdjustTokenPrivileges(hToken, FALSE, &newPrivs , 0, NULL, NULL)) {
        printf("AdjustTokenPrivileges() selhalo - > %d", GetLastError());
        CloseHandle (hToken);
        return -1;
    }

    if (GetLastError() == ERROR_NOT_ALL_ASSIGNED) 
        printf(
"AdjustTokenPrivileges() spn, ale ne vechna oprvnn nastavena\n");

    CloseHandle (hToken);
    return 0;
}

void DoIt(char *szFileName, DWORD dwFlags) {

    printf("\n\nPokus o ten %s, s pznaky 0x%x\ n",
           szFileName, dwFlags);

    HANDLE hFile = CreateFile(szFileName,
                              GENERIC_READ, FILE_SHARE_READ,
                              NULL, OPEN_EXISTING,
                              dwFlags,
                              NULL);
   
    if (hFile == INVALID_HANDLE_VALUE) {
        printf("CreateFile() selhalo - > %d", GetLastError());
        return;
    }

    char buff[128];
    DWORD cbRead=0, cbBuff = sizeof buff;
    ZeroMemory(buff, sizeof buff);

    if (ReadFile(hFile, buff, cbBuff, &cbRead, NULL)) {
        printf("spch, peteno %d bajt\n\nText je: %s",
               cbRead, buff);
    } else {
        printf("ReadFile() selhalo - > %d", GetLastError());
    }
    CloseHandle(hFile);
}

void main(int argc, char* argv[]) {
    if (argc < 2) {
       printf("Voln: %s <filename>", argv[0]);
       return;
    }

    // Nejprve musme zapnout oprvnn k zlohovn.
    if (EnablePriv(SE_BACKUP_NAME) == -1) 
        return;

    // Te to zkusme bez pznaku zlohovn  pstup bude odepen.
    DoIt(argv[1], FILE_ATTRIBUTE_NORMAL);

    // Podruh s pznakem zlohovn  to u by mlo projt!
    DoIt(argv[1], FILE_ATTRIBUTE_NORMAL | FILE_FLAG_BACKUP_SEMANTICS);
}
