// DPAPI.cpp : definuje vstupn bod konzolov aplikace.
//

#include "stdafx.h"
#include <stdlib.h>

void main() {

    // Tato data potebujeme chrnit 
    DATA_BLOB blobIn;
    blobIn.pbData = reinterpret_cast<BYTE *>("To jsou moje tajn data."); 
    blobIn.cbData = lstrlen(reinterpret_cast<char *>(blobIn.pbData))+1;
   
    // Voliteln entropie, zadvan volnm extern funkce 
    DATA_BLOB blobEntropy;

    blobEntropy.pbData = GetEntropyFromUser();
    blobEntropy.cbData = lstrlen(
       reinterpret_cast<char *>(blobEntropy.pbData));

    // Zaifrovat data.
    DATA_BLOB blobOut;
    DWORD dwFlags = CRYPTPROTECT_AUDIT;
    if(CryptProtectData(
            &blobIn,
            L"Pklad z bezpenho kdu", 
            &blobEntropy,                         
            NULL,  
            NULL,  
            dwFlags,
            &blobOut))   {
        printf("Ochrana je v podku.\n");
    } else {
        printf("Chyba pi voln CryptProtectData() -> %x", 
               GetLastError());
        exit(-1);
    }

    // Deifrovat data.
    DATA_BLOB blobVerify;
    if (CryptUnprotectData(
          &blobOut,
          NULL,
          &blobEntropy,
          NULL,     
          NULL,       
          0,
          &blobVerify)) {
          printf("Deifrovan data jsou: %s\n", blobVerify.pbData);
    } else {
        printf("Chyba pi voln CryptUnprotectData() -> %x", 
               GetLastError());
        exit(-1);
    }

    LocalFree(blobOut.pbData);
    LocalFree(blobVerify.pbData);

}
