using System.Reflection;
using System.Runtime.CompilerServices;

//
// Obecn informace o sestaven jsou definovny pomoc nsledujc
// mnoiny atribut. Jejich zmnou je mon modifikovat informace 
// spojen s danm sestavenm.
//
[assembly: AssemblyTitle("")]
[assembly: AssemblyDescription("")]
[assembly: AssemblyConfiguration("")]
[assembly: AssemblyCompany("")]
[assembly: AssemblyProduct("")]
[assembly: AssemblyCopyright("")]
[assembly: AssemblyTrademark("")]
[assembly: AssemblyCulture("")]		

//
// Informace o verzi sestaven se skld z nsledujcch ty hodnot:
//
//      Hlavn verze
//      Vedlej verze
//      slo sestaven
//      Revize
//
// Mete zsdat vechny hodnoty, nebo slo sestaven a Revize ponechat vchoz
// sta zapsat '*', viz ne:

[assembly: AssemblyVersion("1.0.*")]

//
// Pi podepisovn sestaven muste zadat kl. Dal informace 
// o podepisovn sestaven najdete v dokumentaci Microsoft .NET Framework.
//
// Kter kl se pouije pro podepisovn, to uruj ne uveden atributy. 
//
// Poznmky: 
//   (*) Nen-li zadn dn kl, nebude sestaven podepsno.
//   (*) KeyName oznauje kl, kter byl instalovn v Crypto Service
//       Provider (CSP) na danm potai. KeyFile ukazuje na soubor,
//       kter obsahuje kl.
//   (*) Pokud jsou zadny ob hodnoty KeyFile a KeyName, 
//       probhne toto zpracovn:
//       (1) Pokud se KeyName nachz v CSP, pouije se tento kl.
//       (2) Pokud KeyName neexistuje a KeyFile existuje, nainstaluje
//           se kl v KeyFile do CSP a pot se pouije.
//   (*) Pro vytvoen KeyFile mete vyut utilitu sn.exe (Strong Name).
//       Pi zadvn KeyFile mus bt jeho umstn definovno relativn
//       vzhledem k vstupnmu adresi projektu, kterm je 
//       %Project Directory%\obj\<configuration>. Pokud se napklad KeyFile 
//       nachz v adresi projektu, zadte atribut AssemblyKeyFile 
//       jako [assembly: AssemblyKeyFile("..\\..\\mykey.snk")]
//   (*) Delay Signing je pokroil volba  podrobnj informace viz 
//       dokumentace k Microsoft .NET Framework.
//
[assembly: AssemblyDelaySign(false)]
[assembly: AssemblyKeyFile("")]
[assembly: AssemblyKeyName("")]
