#include <windows.h> 

HANDLE CreateTempFile(LPCTSTR szPrefix) {

   // Zjistit doasn adres.
   TCHAR szDir[MAX_PATH];
   if (GetTempPath(sizeof(szDir)/sizeof(TCHAR), szDir) == 0)
       return NULL;

   // Vytvoit jedinen nzev doasnho souboru v adresi temp.
   TCHAR szFileName[MAX_PATH];
   if (!GetTempFileName(szDir, szPrefix, 0, szFileName))
       return NULL;

   // Otevt doasn soubor.
   HANDLE hTemp = CreateFile(szFileName,
                        GENERIC_READ | GENERIC_WRITE,
                        0,      // Nesdlet.
                        NULL,   // Vchoz popisova zabezpeen. 
                        CREATE_ALWAYS,   
                        FILE_ATTRIBUTE_NOT_CONTENT_INDEXED | 
                        FILE_ATTRIBUTE_TEMPORARY | 
                        FILE_FLAG_DELETE_ON_CLOSE,
                        NULL);

   return hTemp == INVALID_HANDLE_VALUE 
                   ? NULL 
                   : hTemp;
}

int main() {
    BOOL fRet = FALSE;
    HANDLE h = CreateTempFile(TEXT("tmp"));
    if (h) {
      
        //
        // Te s doasnm souborem udlme, co potebujeme.
        //

        CloseHandle(h);
    }
    return 0;
}
